signature Trace where {
import Counter;
		 
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import Inout;
	       
import List;
	      
import Clocks;
		
import ListN;
	       
import PrimArray;
		   
import Vector;
		
import Connectable;
		     
import GetPut;
		
import ClientServer;
		      
class (Trace.Traceable :: * -> *) item_t where {
    Trace.traceTiny :: Prelude.String ->
		       Prelude.String -> item_t -> Prelude.Action {-# arg_names = [loc, traceTag, item] #-};
    Trace.traceFull :: Prelude.String ->
		       Prelude.String -> item_t -> Prelude.Action {-# arg_names = [loc, traceTag, item] #-}
};
 
instance Trace Trace.Traceable Prelude.String;
						   
instance Trace Trace.Traceable (Prelude.Bit n);
						    
Trace.traceGet :: (Trace.Traceable item_t) =>
		  Prelude.String -> Prelude.String -> GetPut.Get item_t -> GetPut.Get item_t;
														    
Trace.tracePut :: (Trace.Traceable item_t) =>
		  Prelude.String -> Prelude.String -> GetPut.Put item_t -> GetPut.Put item_t;
														    
Trace.traceClient :: (Trace.Traceable resp_t, Trace.Traceable req_t) =>
		     Prelude.String ->
		     Prelude.String ->
		     Prelude.String ->
		     ClientServer.Client req_t resp_t -> ClientServer.Client req_t resp_t;
												     
Trace.traceServer :: (Trace.Traceable resp_t, Trace.Traceable req_t) =>
		     Prelude.String ->
		     Prelude.String ->
		     Prelude.String ->
		     ClientServer.Server req_t resp_t -> ClientServer.Server req_t resp_t
}
